<template>
  <main>
    <mt-page-title>
      <h1 class="has-text-weight-bold is-size-3">Créer une activité partagée</h1>
      <span class="has-text-weight-bold is-size-6 mt-grey is-uppercase">Activité portée par l'unité </span>
      <span class="has-text-weight-bold is-size-6 mt-grey">{{ uniteParent.libelle }}</span>
    </mt-page-title>
    <form @submit.prevent="submit">
      <mt-form-fields-activity
        :activite="activite"
        :effectif-previsionnel="effectifPrevisionnel"
        :from-parent="true"
        :pax-max="nombrePax"
        @majEffectifPrevisionnel="majEffectifPrevisionnel"
      />
      <footer class="columns is-vcentered mt-margin-top is-centered ">
        <div class="column is-narrow-desktop">
          <nuxt-link :to="{ name: 'index' }">
            <b-button class="mt-button has-text-weight-semibold is-size-8" type="is-secondary" expanded>
              annuler
            </b-button>
          </nuxt-link>
        </div>
        <div class="column is-narrow-desktop">
          <b-button
            class="mt-button has-text-weight-semibold is-size-8"
            type="is-primary"
            native-type="submit"
            expanded
          >
            Créer l’activité
          </b-button>
        </div>
      </footer>
      <mt-modal-ok :ouvert.sync="ouvert" @action="visualiser">
        L’activité a bien été créée.
      </mt-modal-ok>
    </form>
  </main>
</template>

<script>
import MtPageTitle from '~/components/base/page-title/index';
import MtFormFieldsActivity from '~/components/activity/form-fields-activity';
import { newActivity, activityFromParent, creationActivite } from '~/components/mixins/activityMixin';
import MtModalOk from '~/components/modal/mt-modal-ok';

export default {
  layout: 'container-small',
  components: {
    MtModalOk,
    MtPageTitle,
    MtFormFieldsActivity,
  },
  mixins: [creationActivite],
  async asyncData(context) {
    let activite = await context.$api.activites.getFromParent(context.params.id);
    const uniteParent = activite.organisme;
    activite = Object.assign(newActivity(context.store), activite, activityFromParent(context.store));
    const visu = context.query && context.query.visu ? context.query.visu : null;
    const [nombrePax, effectifPrevisionnel] = await Promise.all([
      context.$api.activites.nombreDePax(activite.organisme.id),
      context.$api.organisme().disponibilitesComplete(activite.dateDebut.toISOString(), activite.dateFin.toISOString()),
    ]);
    return {
      effectifPrevisionnel,
      activite,
      visu,
      nombrePax,
      uniteParent,
    };
  },
  methods: {
    visualiser() {
      this.$router.push(
        this.profilLink({ name: 'activites-id', params: { id: this.activite.id }, query: { visu: this.visu } }),
      );
    },
    async majEffectifPrevisionnel() {
      if (this.activite.dateDebut && this.activite.dateFin) {
        this.effectifPrevisionnel = await this.$api
          .organisme()
          .disponibilitesComplete(this.activite.dateDebut.toISOString(), this.activite.dateFin.toISOString());
      }
    },
  },
};
</script>

<style scoped lang="scss">
.commentaire {
  text-align: initial;
}
</style>
